diff -Naur openssl-1.0.0q.orig/crypto/crypto.h openssl-1.0.0q/crypto/crypto.h
--- openssl-1.0.0q.orig/crypto/crypto.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/crypto.h	2017-04-25 16:23:40.146527558 +0200
@@ -117,12 +117,16 @@
 #ifndef HEADER_CRYPTO_H
 #define HEADER_CRYPTO_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 
 #ifndef OPENSSL_NO_FP_API
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #include <openssl/stack.h>
@@ -231,15 +235,15 @@
 #ifndef OPENSSL_NO_LOCKING
 #ifndef CRYPTO_w_lock
 #define CRYPTO_w_lock(type)	\
-	CRYPTO_lock(CRYPTO_LOCK|CRYPTO_WRITE,type,__FILE__,__LINE__)
+	CRYPTO_lock(CRYPTO_LOCK|CRYPTO_WRITE,type,/*__FILE__*/ "",__LINE__)
 #define CRYPTO_w_unlock(type)	\
-	CRYPTO_lock(CRYPTO_UNLOCK|CRYPTO_WRITE,type,__FILE__,__LINE__)
+	CRYPTO_lock(CRYPTO_UNLOCK|CRYPTO_WRITE,type,/*__FILE__*/ "",__LINE__)
 #define CRYPTO_r_lock(type)	\
-	CRYPTO_lock(CRYPTO_LOCK|CRYPTO_READ,type,__FILE__,__LINE__)
+	CRYPTO_lock(CRYPTO_LOCK|CRYPTO_READ,type,/*__FILE__*/ "",__LINE__)
 #define CRYPTO_r_unlock(type)	\
-	CRYPTO_lock(CRYPTO_UNLOCK|CRYPTO_READ,type,__FILE__,__LINE__)
+	CRYPTO_lock(CRYPTO_UNLOCK|CRYPTO_READ,type,/*__FILE__*/ "",__LINE__)
 #define CRYPTO_add(addr,amount,type)	\
-	CRYPTO_add_lock(addr,amount,type,__FILE__,__LINE__)
+	CRYPTO_add_lock(addr,amount,type,/*__FILE__*/ "",__LINE__)
 #endif
 #else
 #define CRYPTO_w_lock(a)
@@ -353,8 +357,13 @@
 		CRYPTO_dbg_get_options);\
 	} while(0)
 
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_mem_ctrl(int mode);
 int CRYPTO_is_mem_check_on(void);
+#else
+#define CRYPTO_mem_ctrl(x)
+#define CRYPTO_is_mem_check_on()
+#endif /* OPERA_SMALL_VERSION */
 
 /* for applications */
 #define MemCheck_start() CRYPTO_mem_ctrl(CRYPTO_MEM_CHECK_ON)
@@ -365,19 +374,19 @@
 #define MemCheck_off()	CRYPTO_mem_ctrl(CRYPTO_MEM_CHECK_DISABLE)
 #define is_MemCheck_on() CRYPTO_is_mem_check_on()
 
-#define OPENSSL_malloc(num)	CRYPTO_malloc((int)num,__FILE__,__LINE__)
+#define OPENSSL_malloc(num)	CRYPTO_malloc((int)num,/*__FILE__*/ NULL,/*__LINE__*/0)
 #define OPENSSL_strdup(str)	CRYPTO_strdup((str),__FILE__,__LINE__)
 #define OPENSSL_realloc(addr,num) \
-	CRYPTO_realloc((char *)addr,(int)num,__FILE__,__LINE__)
+	CRYPTO_realloc((char *)addr,(int)num,/*__FILE__*/ NULL,/*__LINE__*/0)
 #define OPENSSL_realloc_clean(addr,old_num,num) \
-	CRYPTO_realloc_clean(addr,old_num,num,__FILE__,__LINE__)
+	CRYPTO_realloc_clean(addr,old_num,num,/*__FILE__*/ NULL,/*__LINE__*/0)
 #define OPENSSL_remalloc(addr,num) \
-	CRYPTO_remalloc((char **)addr,(int)num,__FILE__,__LINE__)
+	CRYPTO_remalloc((char **)addr,(int)num,/*__FILE__*/ NULL/*,__LINE__*/0)
 #define OPENSSL_freeFunc	CRYPTO_free
 #define OPENSSL_free(addr)	CRYPTO_free(addr)
 
 #define OPENSSL_malloc_locked(num) \
-	CRYPTO_malloc_locked((int)num,__FILE__,__LINE__)
+	CRYPTO_malloc_locked((int)num,/*__FILE__*/ "",__LINE__)
 #define OPENSSL_free_locked(addr) CRYPTO_free_locked(addr)
 
 
@@ -497,15 +506,25 @@
 			   int line);
 void *CRYPTO_remalloc(void *addr,int num, const char *file, int line);
 
+#if defined OPERA_SMALL_VERSION
+#define OPENSSL_cleanse OPERA_cleanse
+#endif
+
 void OPENSSL_cleanse(void *ptr, size_t len);
 
 void CRYPTO_set_mem_debug_options(long bits);
 long CRYPTO_get_mem_debug_options(void);
 
+#ifndef OPERA_SMALL_VERSION
 #define CRYPTO_push_info(info) \
-        CRYPTO_push_info_(info, __FILE__, __LINE__);
+        CRYPTO_push_info_(info, /*__FILE__*/ "", __LINE__);
 int CRYPTO_push_info_(const char *info, const char *file, int line);
 int CRYPTO_pop_info(void);
+#else
+#define CRYPTO_push_info(x)
+#define CRYPTO_push_info_(x,y,z,w)
+#define CRYPTO_pop_info()
+#endif
 int CRYPTO_remove_all_info(void);
 
 
@@ -541,7 +560,11 @@
 
 /* die if we have to */
 void OpenSSLDie(const char *file,int line,const char *assertion);
+#ifndef OPERA_SMALL_VERSION
 #define OPENSSL_assert(e)       (void)((e) ? 0 : (OpenSSLDie(__FILE__, __LINE__, #e),1))
+#else
+#define OPENSSL_assert(e)       OP_ASSERT(e)
+#endif
 
 unsigned long *OPENSSL_ia32cap_loc(void);
 #define OPENSSL_ia32cap (*(OPENSSL_ia32cap_loc()))
diff -Naur openssl-1.0.0q.orig/crypto/des/.gitignore openssl-1.0.0q/crypto/des/.gitignore
--- openssl-1.0.0q.orig/crypto/des/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/des/.gitignore	2017-04-25 16:23:40.147527406 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/des/cbc3_enc.c openssl-1.0.0q/crypto/des/cbc3_enc.c
--- openssl-1.0.0q.orig/crypto/des/cbc3_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/cbc3_enc.c	2017-04-25 16:23:40.148527254 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
-#include "des_locl.h"
+#include <openssl/cryptlib.h>
 
+#include "des_locl.h"
+#ifndef OPERA_SMALL_VERSION
 /* HAS BUGS! DON'T USE - this is only present for use in des.c */
 void DES_3cbc_encrypt(DES_cblock *input, DES_cblock *output, long length,
 	     DES_key_schedule ks1, DES_key_schedule ks2, DES_cblock *iv1,
@@ -72,28 +74,29 @@
 		DES_cbc_encrypt((unsigned char*)input,
 				(unsigned char*)output,length,&ks1,iv1,enc);
 		if (length >= sizeof(DES_cblock))
-			memcpy(niv1,output[off],sizeof(DES_cblock));
+			op_memcpy(niv1,output[off],sizeof(DES_cblock));
 		DES_cbc_encrypt((unsigned char*)output,
 				(unsigned char*)output,l8,&ks2,iv1,!enc);
 		DES_cbc_encrypt((unsigned char*)output,
 				(unsigned char*)output,l8,&ks1,iv2,enc);
 		if (length >= sizeof(DES_cblock))
-			memcpy(niv2,output[off],sizeof(DES_cblock));
+			op_memcpy(niv2,output[off],sizeof(DES_cblock));
 		}
 	else
 		{
 		if (length >= sizeof(DES_cblock))
-			memcpy(niv2,input[off],sizeof(DES_cblock));
+			op_memcpy(niv2,input[off],sizeof(DES_cblock));
 		DES_cbc_encrypt((unsigned char*)input,
 				(unsigned char*)output,l8,&ks1,iv2,enc);
 		DES_cbc_encrypt((unsigned char*)output,
 				(unsigned char*)output,l8,&ks2,iv1,!enc);
 		if (length >= sizeof(DES_cblock))
-			memcpy(niv1,output[off],sizeof(DES_cblock));
+			op_memcpy(niv1,output[off],sizeof(DES_cblock));
 		DES_cbc_encrypt((unsigned char*)output,
 				(unsigned char*)output,length,&ks1,iv1,enc);
 		}
-	memcpy(*iv1,niv1,sizeof(DES_cblock));
-	memcpy(*iv2,niv2,sizeof(DES_cblock));
+	op_memcpy(*iv1,niv1,sizeof(DES_cblock));
+	op_memcpy(*iv2,niv2,sizeof(DES_cblock));
 	}
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/des/cfb64ede.c openssl-1.0.0q/crypto/des/cfb64ede.c
--- openssl-1.0.0q.orig/crypto/des/cfb64ede.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/cfb64ede.c	2017-04-25 16:23:40.149528219 +0200
@@ -56,8 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#include <openssl/cryptlib.h>
+
+#if !defined OPENSSL_NO_DES && defined OPENSSL_USE_CFB_CIPHERS
+
 #include "des_locl.h"
-#include "e_os.h"
+#include <openssl/e_os.h>
 
 /* The input and output encrypted as though 64bit cfb mode is being
  * used.  The extra state information to record how much of the
@@ -156,7 +160,7 @@
 	register int num=numbits,i;
 	DES_LONG ti[2];
 	unsigned char *iv;
-	unsigned char ovec[16];
+	unsigned char ovec[16]; /* ARRAY OK 2007-11-07 yngve */
 
 	if (num > 64) return;
 	iv = &(*ivec)[0];
@@ -190,7 +194,7 @@
 				l2c(d0,iv);
 				l2c(d1,iv);
 				/* shift ovec left most of the bits... */
-				memmove(ovec,ovec+num/8,8+(num%8 ? 1 : 0));
+				op_memmove(ovec,ovec+num/8,8+(num%8 ? 1 : 0));
 				/* now the remaining bits */
 				if(num%8 != 0)
 					for(i=0 ; i < 8 ; ++i)
@@ -228,7 +232,7 @@
 				l2c(d0,iv);
 				l2c(d1,iv);
 				/* shift ovec left most of the bits... */
-				memmove(ovec,ovec+num/8,8+(num%8 ? 1 : 0));
+				op_memmove(ovec,ovec+num/8,8+(num%8 ? 1 : 0));
 				/* now the remaining bits */
 				if(num%8 != 0)
 					for(i=0 ; i < 8 ; ++i)
@@ -252,3 +256,4 @@
 	v0=v1=d0=d1=ti[0]=ti[1]=0;
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/des/cfb64enc.c openssl-1.0.0q/crypto/des/cfb64enc.c
--- openssl-1.0.0q.orig/crypto/des/cfb64enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/cfb64enc.c	2017-04-25 16:23:40.150527787 +0200
@@ -56,6 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#include <openssl/cryptlib.h>
+
+#if !defined OPENSSL_NO_DES && defined OPENSSL_USE_CFB_CIPHERS
+
 #include "des_locl.h"
 
 /* The input and output encrypted as though 64bit cfb mode is being
@@ -119,3 +123,4 @@
 	*num=n;
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/des/cfb_enc.c openssl-1.0.0q/crypto/des/cfb_enc.c
--- openssl-1.0.0q.orig/crypto/des/cfb_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/cfb_enc.c	2017-04-25 16:23:40.152527483 +0200
@@ -56,7 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
-#include "e_os.h"
+#include <openssl/cryptlib.h>
+
+#if !defined OPENSSL_NO_DES && defined OPENSSL_USE_CFB_CIPHERS
+
+#include <openssl/e_os.h>
 #include "des_locl.h"
 #include <assert.h>
 
@@ -78,7 +82,7 @@
 	DES_LONG ti[2];
 	unsigned char *iv;
 #ifndef L_ENDIAN
-	unsigned char ovec[16];
+	unsigned char ovec[16]; /* ARRAY OK 2007-11-07 yngve */
 #else
 	unsigned int  sh[4];
 	unsigned char *ovec=(unsigned char *)sh;
@@ -125,7 +129,7 @@
 				sh[0]=v0, sh[1]=v1, sh[2]=d0, sh[3]=d1;
 #endif
 				if (rem==0)
-					memmove(ovec,ovec+num,8);
+					op_memmove(ovec,ovec+num,8);
 				else
 					for(i=0 ; i < 8 ; ++i)
 						ovec[i]=ovec[i+num]<<rem |
@@ -168,7 +172,7 @@
 				sh[0]=v0, sh[1]=v1, sh[2]=d0, sh[3]=d1;
 #endif
 				if (rem==0)
-					memmove(ovec,ovec+num,8);
+					op_memmove (ovec,ovec+num,8);
 				else
 					for(i=0 ; i < 8 ; ++i)
 						ovec[i]=ovec[i+num]<<rem |
@@ -193,3 +197,4 @@
 	v0=v1=d0=d1=ti[0]=ti[1]=0;
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/des/des.c openssl-1.0.0q/crypto/des/des.c
--- openssl-1.0.0q.orig/crypto/des/des.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/des.c	2017-04-25 16:23:40.153527610 +0200
@@ -56,9 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/opensslconf.h>
 #ifndef OPENSSL_SYS_MSDOS
 #ifndef OPENSSL_SYS_VMS
@@ -71,10 +76,14 @@
 #endif /* __DECC */
 #endif /* OPENSSL_SYS_VMS */
 #else /* OPENSSL_SYS_MSDOS */
+#ifndef OPERA_SMALL_VERSION
 #include <io.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "des_ver.h"
 
 #ifdef OPENSSL_SYS_VMS
@@ -82,9 +91,13 @@
 #include <stat.h>
 #else
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
+#ifndef OPERA_SMALL_VERSION
 #include <sys/stat.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #include <openssl/des.h>
 #include <openssl/rand.h>
@@ -134,7 +147,7 @@
 
 	vflag=cflag=eflag=dflag=kflag=hflag=bflag=fflag=sflag=uflag=flag3=0;
 	error=0;
-	memset(key,0,sizeof(key));
+	op_memset(key,0,sizeof(key));
 
 	for (i=1; i<argc; i++)
 		{
@@ -152,16 +165,16 @@
 					break;
 				case 'c':
 					cflag=1;
-					strncpy(cksumname,p,200);
+					op_strncpy(cksumname,p,200);
 					cksumname[sizeof(cksumname)-1]='\0';
-					p+=strlen(cksumname);
+					p+=op_strlen(cksumname);
 					break;
 				case 'C':
 					cflag=1;
 					longk=1;
-					strncpy(cksumname,p,200);
+					op_strncpy(cksumname,p,200);
 					cksumname[sizeof(cksumname)-1]='\0';
-					p+=strlen(cksumname);
+					p+=op_strlen(cksumname);
 					break;
 				case 'e':
 					eflag=1;
@@ -191,9 +204,9 @@
 					break;
 				case 'u':
 					uflag=1;
-					strncpy(uuname,p,200);
+					op_strncpy(uuname,p,200);
 					uuname[sizeof(uuname)-1]='\0';
-					p+=strlen(uuname);
+					p+=op_strlen(uuname);
 					break;
 				case 'h':
 					hflag=1;
@@ -210,8 +223,8 @@
 						int j;
 
 						i++;
-						strncpy(key,argv[i],KEYSIZB);
-						for (j=strlen(argv[i])-1; j>=0; j--)
+						op_strncpy(key,argv[i],KEYSIZB);
+						for (j=op_strlen(argv[i])-1; j>=0; j--)
 							argv[i][j]='\0';
 						}
 					break;
@@ -268,7 +281,7 @@
 		(ins.st_dev == outs.st_dev) &&
 		(ins.st_ino == outs.st_ino))
 #else /* OPENSSL_SYS_MSDOS */
-		(strcmp(in,out) == 0))
+		(op_strcmp(in,out) == 0))
 #endif
 			{
 			fputs("input and output file are the same\n",stderr);
@@ -305,7 +318,9 @@
 #ifdef OPENSSL_SYS_MSDOS
 	/* This should set the file to binary mode. */
 	{
+#ifndef OPERA_SMALL_VERSION
 #include <fcntl.h>
+#endif /* !OPERA_SMALL_VERSION */
 	if (!(uflag && dflag))
 		setmode(fileno(DES_IN),O_BINARY);
 	if (!(uflag && eflag))
@@ -360,7 +375,7 @@
 void doencryption(void)
 	{
 #ifdef _LIBC
-	extern unsigned long time();
+	extern unsigned long op_time();
 #endif
 
 	register int i;
@@ -460,8 +475,8 @@
 	OPENSSL_cleanse(key,sizeof(key));
 	OPENSSL_cleanse(kk,sizeof(kk));
 	/* woops - A bug that does not showup under unix :-( */
-	memset(iv,0,sizeof(iv));
-	memset(iv2,0,sizeof(iv2));
+	op_memset(iv,0,sizeof(iv));
+	op_memset(iv2,0,sizeof(iv2));
 
 	l=1;
 	rem=0;
@@ -520,13 +535,13 @@
 				{
 				char tmpbuf[8];
 
-				if (rem) memcpy(tmpbuf,&(buf[l]),
+				if (rem) op_memcpy(tmpbuf,&(buf[l]),
 					(unsigned int)rem);
 				DES_3cbc_encrypt(
 					(DES_cblock *)buf,(DES_cblock *)obuf,
 					(long)l,ks,ks2,&iv,
 					&iv2,do_encrypt);
-				if (rem) memcpy(&(buf[l]),tmpbuf,
+				if (rem) op_memcpy(&(buf[l]),tmpbuf,
 					(unsigned int)rem);
 				}
 			else
@@ -534,9 +549,9 @@
 				DES_cbc_encrypt(
 					buf,obuf,
 					(long)l,&ks,&iv,do_encrypt);
-				if (l >= 8) memcpy(iv,&(obuf[l-8]),8);
+				if (l >= 8) op_memcpy(iv,&(obuf[l-8]),8);
 				}
-			if (rem) memcpy(buf,&(buf[l]),(unsigned int)rem);
+			if (rem) op_memcpy(buf,&(buf[l]),(unsigned int)rem);
 
 			i=0;
 			while (i < l)
@@ -607,7 +622,7 @@
 				DES_cbc_encrypt(
 					buf,obuf,
 				 	(long)l,&ks,&iv,do_encrypt);
-				if (l >= 8) memcpy(iv,&(buf[l-8]),8);
+				if (l >= 8) op_memcpy(iv,&(buf[l-8]),8);
 				}
 
 			if (uflag)
@@ -698,14 +713,14 @@
 		{
 		if (uubufnum+num < 45)
 			{
-			memcpy(&(uubuf[uubufnum]),data,(unsigned int)num);
+			op_memcpy(&(uubuf[uubufnum]),data,(unsigned int)num);
 			uubufnum+=num;
 			return(num);
 			}
 		else
 			{
 			i=45-uubufnum;
-			memcpy(&(uubuf[uubufnum]),data,(unsigned int)i);
+			op_memcpy(&(uubuf[uubufnum]),data,(unsigned int)i);
 			j=uuencode((unsigned char *)uubuf,45,b);
 			fwrite(b,1,(unsigned int)j,fp);
 			uubufnum=0;
@@ -729,7 +744,7 @@
 		}
 	if (i != num)
 		{
-		memcpy(uubuf,&(data[i]),(unsigned int)rem);
+		op_memcpy(uubuf,&(data[i]),(unsigned int)rem);
 		uubufnum=rem;
 		}
 	return(ret);
@@ -770,7 +785,7 @@
 				fprintf(stderr,"no 'begin' found in uuencoded input\n");
 				return(-1);
 				}
-			if (strncmp((char *)b,"begin ",6) == 0) break;
+			if (op_strncmp((char *)b,"begin ",6) == 0) break;
 			}
 		start=0;
 		}
@@ -778,7 +793,7 @@
 	tot=0;
 	if (valid)
 		{
-		memcpy(out,bb,(unsigned int)valid);
+		op_memcpy(out,bb,(unsigned int)valid);
 		tot=valid;
 		valid=0;
 		}
@@ -787,7 +802,7 @@
 		b[0]='\0';
 		fgets((char *)b,300,fp);
 		if (b[0] == '\0') break;
-		i=strlen((char *)b);
+		i=op_strlen((char *)b);
 		if ((b[0] == 'e') && (b[1] == 'n') && (b[2] == 'd'))
 			{
 			done=1;
@@ -803,13 +818,13 @@
 			{
 			/* num to copy to make it a multiple of 8 */
 			j=(num/8*8)-tot-8;
-			memcpy(&(out[tot]),bb,(unsigned int)j);
+			op_memcpy(&(out[tot]),bb,(unsigned int)j);
 			tot+=j;
-			memcpy(bb,&(bb[j]),(unsigned int)i-j);
+			op_memcpy(bb,&(bb[j]),(unsigned int)i-j);
 			valid=i-j;
 			break;
 			}
-		memcpy(&(out[tot]),bb,(unsigned int)i);
+		op_memcpy(&(out[tot]),bb,(unsigned int)i);
 		tot+=i;
 		}
 	return(tot);
diff -Naur openssl-1.0.0q.orig/crypto/des/des.h openssl-1.0.0q/crypto/des/des.h
--- openssl-1.0.0q.orig/crypto/des/des.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/des/des.h	2017-04-25 16:23:40.154527458 +0200
@@ -75,8 +75,8 @@
 extern "C" {
 #endif
 
-typedef unsigned char DES_cblock[8];
-typedef /* const */ unsigned char const_DES_cblock[8];
+typedef unsigned char DES_cblock[8];					/* ARRAY OK 2009-05-25 yngve */
+typedef /* const */ unsigned char const_DES_cblock[8];	/* ARRAY OK 2009-05-25 yngve */
 /* With "const", gcc 2.8.1 on Solaris thinks that DES_cblock *
  * and const_DES_cblock * are incompatible pointer types. */
 
diff -Naur openssl-1.0.0q.orig/crypto/des/des3s.cpp openssl-1.0.0q/crypto/des/des3s.cpp
--- openssl-1.0.0q.orig/crypto/des/des3s.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/des3s.cpp	2017-04-25 16:23:40.155527026 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/des.h>
 
 void main(int argc,char *argv[])
diff -Naur openssl-1.0.0q.orig/crypto/des/des_enc.c openssl-1.0.0q/crypto/des/des_enc.c
--- openssl-1.0.0q.orig/crypto/des/des_enc.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/des_enc.c	2017-04-25 16:23:40.156527153 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#include <openssl/cryptlib.h>
 #include "des_locl.h"
 #include "spr.h"
 
+#ifdef SSL_USE_WEAK_CIPHERS
 void DES_encrypt1(DES_LONG *data, DES_key_schedule *ks, int enc)
 	{
 	register DES_LONG l,r,t,u;
@@ -152,6 +154,7 @@
 	data[1]=r;
 	l=r=t=u=0;
 	}
+#endif // SSL_USE_WEAK_CIPHERS
 
 void DES_encrypt2(DES_LONG *data, DES_key_schedule *ks, int enc)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/des/des_locl.h openssl-1.0.0q/crypto/des/des_locl.h
--- openssl-1.0.0q.orig/crypto/des/des_locl.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/des_locl.h	2017-04-25 16:23:40.157526721 +0200
@@ -67,30 +67,38 @@
 #endif
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #ifndef OPENSSL_SYS_MSDOS
 #if !defined(OPENSSL_SYS_VMS) || defined(__DECC)
+#ifndef OPERA_SMALL_VERSION
 #ifdef OPENSSL_UNISTD
 # include OPENSSL_UNISTD
 #else
 # include <unistd.h>
 #endif
 #include <math.h>
+#endif // OPERA_SMALL_VERSION
 #endif
 #endif
 #include <openssl/des.h>
 
 #ifdef OPENSSL_SYS_MSDOS		/* Visual C++ 2.1 (Windows NT/95) */
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
 #include <errno.h>
 #include <time.h>
 #include <io.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #if defined(__STDC__) || defined(OPENSSL_SYS_VMS) || defined(M_XENIX) || defined(OPENSSL_SYS_MSDOS)
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #ifdef OPENSSL_BUILD_SHLIBCRYPTO
@@ -162,7 +170,7 @@
 
 #if (defined(OPENSSL_SYS_WIN32) && defined(_MSC_VER)) || defined(__ICC)
 #define	ROTATE(a,n)	(_lrotr(a,n))
-#elif defined(__GNUC__) && __GNUC__>=2 && !defined(__STRICT_ANSI__) && !defined(OPENSSL_NO_ASM) && !defined(OPENSSL_NO_INLINE_ASM) && !defined(PEDANTIC)
+#elif defined(__GNUC__) && __GNUC__>=2 && !defined(__STRICT_ANSI__) && !defined(OPENSSL_NO_ASM) && !defined(OPENSSL_NO_INLINE_ASM) && !defined(PEDANTIC) && !defined(__llvm__)
 # if defined(__i386) || defined(__i386__) || defined(__x86_64) || defined(__x86_64__)
 #  define ROTATE(a,n)	({ register unsigned int ret;	\
 				asm ("rorl %1,%0"	\
diff -Naur openssl-1.0.0q.orig/crypto/des/des_opts.c openssl-1.0.0q/crypto/des/des_opts.c
--- openssl-1.0.0q.orig/crypto/des/des_opts.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/des_opts.c	2017-04-25 16:23:40.158526569 +0200
@@ -63,12 +63,16 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifndef OPENSSL_SYS_MSDOS
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD
 #else
+#ifndef OPERA_SMALL_VERSION
 #include <io.h>
+#endif /* !OPERA_SMALL_VERSION */
 extern void exit();
 #endif
 
@@ -77,10 +81,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -99,7 +107,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/des/dess.cpp openssl-1.0.0q/crypto/des/dess.cpp
--- openssl-1.0.0q.orig/crypto/des/dess.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/dess.cpp	2017-04-25 16:23:40.159526138 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/des.h>
 
 void main(int argc,char *argv[])
